package pl.edu.s3996.zad5;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;

/**
 * Created by Adam on 2014-06-03.
 */
public class ServletList extends HttpServlet {

    private DataSource dataSource;

    public void init() throws ServletException {
        try {
            Context init = new InitialContext();
            Context contx = (Context) init.lookup("java:comp/env");
            dataSource = (DataSource) contx.lookup("jdbc/usersdb");
        } catch (NamingException exc) {
            throw new ServletException(
                    "Nie mogę uzyskać źródła java:comp/env/jdbc/usersdb", exc);
        }
    }


    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        serviceRequest(request, response);
    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        serviceRequest(request, response);
    }

    public void serviceRequest(HttpServletRequest req,
                               HttpServletResponse resp)
            throws ServletException, IOException
    {
        resp.setContentType("text/html; charset=windows-1250");
        PrintWriter out = resp.getWriter();
        out.println("<h1>Lista użytkowników</h1>");
        out.println("<table border=1 style=width:50%>");
        out.println("<tr><th>ID</th><th>Nazwa</th><th>Hasło</th><th>Akcje</th></tr>");
        Connection con = null;

        try {
            synchronized (dataSource) {
                con = dataSource.getConnection();
            }
            String username = req.getParameter("username");
            String password = req.getParameter("password");
            if (username != null &&  password != null  && username != "" && password != "")
            {


                PreparedStatement addStatement = con.prepareStatement("INSERT INTO users (user_name, user_password) VALUES(?,?)");
                addStatement.setString(1, req.getParameter("username"));
                addStatement.setString(2, req.getParameter("password"));
                addStatement.executeUpdate();
            }
            else
            {
                if (req.getMethod() == "POST")
                {
                    out.println("Proszę podac nazwę użytkownika oraz hasło");
                }
            }


            Statement stmt = con.createStatement();

            ResultSet rs = stmt.executeQuery("select * from users");

            while (rs.next())  {
                out.println("<tr>");
                int id = rs.getInt("user_id");
                String name = rs.getString("user_name");
                String pass = rs.getString("user_password");

                out.println("<td>" + id + "</td>");
                out.println("<td>" + name + "</td>");
                out.println("<td>" + pass + "</td>");
                out.println("<td><a href=\"/edit?id="+id +"\"> Edytuj </a></td>");
                out.println("</tr>");
            }
            rs.close();
            stmt.close();
        } catch (Exception exc)  {
            out.println(exc.getMessage());
        } finally {
            try { con.close(); } catch (Exception exc) {}
        }

        out.println("</table>");

        out.println("<h2>Dodaj użytkownika </h2>");
        out.println("<form method=\"POST\">");
        out.println("Nazwa: <br/><input type=\"text\" name=\"username\">");
        out.println("</br>");
        out.println("Hasło: <br/><input type=\"text\" name=\"password\">");
        out.println("</br>");
        out.println("<input type=\"submit\" value=\"Dodaj\">");
        out.println("</form>");

        out.close();
    }



}
