package protocol;


import pl.edu.s3996.zad2.InvalidMessageException;

public class AddRequestMessage extends BaseMessage {

    public static final String MessageType = "ADD_REQUEST";

    public AddRequestMessage() {
        super(MessageType);
    }

    private int firstNumber;
    private int secondNumber;

    public int getFirstNumber() {
        return firstNumber;
    }

    public void setFirstNumber(int firstNumber) {
        this.firstNumber = firstNumber;
    }

    public int getSecondNumber() {
        return secondNumber;
    }

    public void setSecondNumber(int secondNumber) {
        this.secondNumber = secondNumber;
    }

    @Override
    public String toString() {
        return "AddRequestMessage{" +
                "firstNumber=" + firstNumber +
                ", secondNumber=" + secondNumber +
                '}';
    }

    @Override
    public void parseFromString(String s) throws InvalidMessageException {
        super.parseFromString(s);

        if (!isValidMessage(s))
            throw new InvalidMessageException();

        super.parseFromString(s);

        String[] array = s.split(":");

        firstNumber = Integer.parseInt(array[1]);
        secondNumber = Integer.parseInt(array[2]);

    }

    @Override
    public BaseMessage getResponse() {
        AddResponseMessage message = new AddResponseMessage();
        message.setSum(getFirstNumber() + getSecondNumber());
        return message;
    }

    private boolean isValidMessage(String s) {
        String[] array = s.split(":");
        return array.length == 3 && array[0].equals(getMessageName());
    }


    @Override
    public String saveToString() {
        return getMessageName() + ":" + firstNumber + ":" + secondNumber;
    }
}
