package protocol;

import pl.edu.s3996.zad2.InvalidMessageException;

import java.lang.reflect.Type;

public abstract class BaseMessage {
    protected BaseMessage(String messageName) {
        this.messageName = messageName;
    }

    private String messageName;

    public String getMessageBody() {
        return messageBody;
    }

    protected void setMessageBody(String messageBody) {
        this.messageBody = messageBody;
    }

    private String messageBody;


    public String getMessageName() {
        return messageName;
    }


    public void parseFromString(String s) throws InvalidMessageException {
        setMessageBody(s);
    }

    public abstract BaseMessage getResponse();

    public abstract String saveToString();

    public static Type getMessageType(String messageBody) throws Exception {
        if (messageBody.startsWith("ECHO_REQUEST"))
            return EchoRequestMessage.class;
        else if (messageBody.startsWith("ECHO_RESPONSE"))
            return EchoResponseMessage.class;
        else if (messageBody.startsWith("ADD_REQUEST"))
            return AddRequestMessage.class;
        else if (messageBody.startsWith("ADD_RESPONSE"))
            return AddResponseMessage.class;
        else
            throw new Exception("Unknown message type!");
    }


}
